version: '3'

services:
  golang:
    image: golang:1.15
    depends_on:
      elasticsearch:
        condition: service_healthy
      kibana:
        condition: service_healthy
    volumes:
      - ./:/go/src/github.com/pcherednichenko/go-elk
      - ./logs/:/logs/
    working_dir: /go/src/github.com/pcherednichenko/go-elk
    environment:
      - KIBANA_URL=http://172.31.220.183:5601
    command: go run main.go

  filebeat:
    image: docker.elastic.co/beats/filebeat:7.10.2
    depends_on:
      logstash:
        condition: service_healthy
    volumes:
      - ./config/filebeat.yml:/usr/share/filebeat/filebeat.yml
      - ./logs/:/logs/

  logstash:
    image: docker.elastic.co/logstash/logstash:7.10.1
    volumes:
      - ./config/logstash.conf:/usr/share/logstash/pipeline/logstash.conf:ro
    healthcheck:
      test: ["CMD", "curl", "-s", "http://localhost:9600"]
      interval: 3s
      timeout: 3s
      retries: 80
    depends_on:
      elasticsearch:
        condition: service_healthy
    ports:
      - 5044:5044

  elasticsearch:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.10.1
    healthcheck:
      test: ["CMD", "curl", "-s", "-f", "http://localhost:9200/_cat/health"]
      interval: 3s
      timeout: 3s
      retries: 80
    environment:
      - discovery.type=single-node
    ports:
      - 9200:9200

  kibana:
    image: docker.elastic.co/kibana/kibana:7.10.1
    depends_on:
      elasticsearch:
        condition: service_healthy
    healthcheck:
      test: ["CMD", "curl", "-s", "-f", "http://localhost:5601/api/status"]
      interval: 3s
      timeout: 3s
      retries: 80
    ports:
      - 5601:5601
